\section{Testing}

For the testing purpose of the task the separate script code has been created.
It measures the performance of a handwritten text recognition model. It loads an
image, processes it, uses the pre-trained model to predict the text in the
image, and then compares the prediction to the actual text, outputting two
standard measures of text prediction accuracy: CER and WER\@. Detailed consecutive
steps are described below as well as shown on the figure~\ref{fig:testing-flow}.
\begin{figure}[hbpt]
    \begin{center}
        \includegraphics[width=0.35\textwidth]{figures/testing-flow.pdf}
    \end{center}
    \caption{Testing program flow.}%
    \label{fig:testing-flow}
\end{figure}

\begin{enumerate}
    \item \textbf{Configuration}: The script utilizes the Hydra library and
          OmegaConf to manage configurations. The configuration file being used
          is named ,,config'' and resides in a directory also named ,,config''. The
          configuration data is then parsed into an \texttt{OCRConfig} object.

    \item \textbf{Data loading}: The script loads a database of forms using the
          configured paths. Each form is associated with an image and
          corresponding labels. A form is randomly selected from the database for
          testing.

    \item \textbf{Image preprocessing}: The chosen image undergoes several
          preprocessing steps: it's read using OpenCV, converted to grayscale,
          and then binarized. The binary image is used to detect lines that
          segment the image, and the image is then split vertically according to
          the line detections.

    \item \textbf{Line verification}: The number of detected lines is compared
          against the expected number. If they do not match, the program outputs
          a message and ends the test run.

    \item \textbf{Text detection}: For each line, the program detects and
          extracts contours corresponding to words, both in grayscale and in
          color.

    \item \textbf{Text recognition}: The program utilizes a pre-trained model
          to predict the text contained in each extracted word contour. These
          predictions are then concatenated to form the predicted text for the
          entire image.

    \item \textbf{Expected text extraction}: A separate database of lines is
          loaded, and lines belonging to the same form as the randomly chosen
          image are extracted. The text from these lines forms the expected text
          for the image.

    \item \textbf{Comparison and metrics}: The expected and predicted texts are
          printed. In addition, Character Error Rate (CER) and Word Error Rate
          (WER) are computed as metrics to measure the model's performance on the
          chosen image.
\end{enumerate}


\subsection{Results}

\noindent
\begin{minipage}[t]{\textwidth}
    \begin{figure}[H]
        \begin{center}
            \includegraphics[width=0.6\textwidth]{figures/g06-047o.png}
        \end{center}
    \end{figure}
    \begin{minipage}[t]{0.49\textwidth}
        \textbf{Expected text}: This remarkable man of medicine, whom Sir
        Francis Burdett described to Anglesey a year or two later as 'more
        like a God upon earth than a human being', had an increasing number
        of disciples among unorthodox medical men in the cities of Europe.
        One of these was the Neapo- litan, Dr Giuseppe Mauro, whom Anglesey
        consulted in May 1834.
    \end{minipage}%
    \hfill
    \begin{minipage}[t]{0.49\textwidth}
        \textbf{Predicted text}: This remarkable man of medicine; whom biy
        Francis Burderts described to Anglesey o? year or two later os! more
        like o? God upon earth than o? human being, had an incereasing number
        of disciples among unorthodox metical men in the cities of Euope? one
        of these was the neapor litan for Ginseppe Mauoa whom Anglesey
        consulted in may 18.
    \end{minipage}%
    \hfill
    \begin{center}
        \textbf{CER}: 0.10, \textbf{WER}: 0.34
    \end{center}
\end{minipage}

\noindent
\begin{minipage}[t]{\textwidth}
    \begin{figure}[H]
        \begin{center}
            \includegraphics[width=0.6\textwidth]{figures/r03-050.png}
        \end{center}
    \end{figure}
    \begin{minipage}[t]{0.49\textwidth}
        \textbf{Expected text}: His aspect was as dusty as his office, with
        scurf from dusty hair on the dusty shoulders of his black suit, cigarette
        ash down thefront, an ashen face and yellow sleepy dust in the corners of
        his pale grey eyes. His finger-nails were dirty, though he tried to make
        up for it by constantly paring them with the finger-nail of the opposite
        hand.
    \end{minipage}%
    \hfill
    \begin{minipage}[t]{0.49\textwidth}
        \textbf{Predicted text}: His aspect was of dusty of his office, with
        scurt from dusty hair on the dusty shoulders of his black suitt cigarele
        ash down the frout- an asken for by and yellow sleepy dust in the cormers
        of his pale grey eyes? His finger- nails were dinty- though me tried to
        make up for if by controlpaing them with the finger y nail of the
        opposite hand-.
    \end{minipage}%
    \hfill
    \begin{center}
        \textbf{CER}: 0.11, \textbf{WER}: 0.37
    \end{center}
\end{minipage}

\noindent
\begin{minipage}[t]{\textwidth}
    \begin{figure}[H]
        \begin{center}
            \includegraphics[width=0.6\textwidth]{figures/n04-202.png}
        \end{center}
    \end{figure}
    \begin{minipage}[t]{0.49\textwidth}
        \textbf{Expected text}: Glad I met you. Don't forget to give me a
        ring - any time - knock twice and ask for Bawley, what? " " I don't know
        when that will be, " said John. " I shall be busy for a while, cleaning
        up after Master bloody Munyard. " THERE were six submarines, lying in
        pairs alongside the jetty at Fort Blockhouse. Black and grimly
        businesslike they both looked and sounded, for all of them were
        rumblingas they charged their electric batteries.
    \end{minipage}%
    \hfill
    \begin{minipage}[t]{0.49\textwidth}
        \textbf{Predicted text}: blad! met you Doon! forrget bo give me on
        ring? angtime? knodk toice and ast for Bawley? what?::, don!? know chen
        that will be? said John?:? shall be busy for actile? cleaning up after
        Master bloody Manyard?? E were siy summariners lying in pairs aloggide
        the jety of Ford Dathose Blace and grimly boisectine they boly looked and
        sounded? for all of them were membling of they charged their electice
        batteries?
    \end{minipage}%
    \hfill
    \begin{center}
        \textbf{CER}: 0.18, \textbf{WER}: 0.54
    \end{center}
\end{minipage}
